#!/usr/bin/perl

eval{
use Fcntl;
use GDBM_File;
};

if( $@ ){
	print "Content-type:text/html\n\n";
	print "Can't initiate: GDBM_File module was not found.";
	exit;
}	

$DB_Type = 'GDBM_File';

print "Content-type:text/html\n";

%charsets = (
	'gb' => "gb-2312",
	'eng' => "iso-8859-1",
	'fr' => "iso-8859-1",
	'de' => "x-IA5-German",
	'big5' => "big5",
);

read (STDIN, $data, $ENV{'CONTENT_LENGTH'});
@postpairs = split(/&/, $data);
@getpairs = split(/&/, $ENV{'QUERY_STRING'});
foreach $data ( @postpairs, @getpairs ){
	my ($name, $value) = split(/=/, $data);
	$value =~ s/%(..)/pack("c", hex($1))/ge;
	$value =~ s/\+/ /g;
	if( defined $fields{$name} ){
		$fields{$name} .= ( "\t" . $value );
	} else {
		$fields{$name} = $value;
	}
}

if( !$fields{'lang'} ){
	if( $ENV{'HTTP_ACCEPT_LANGUAGE'} =~ /^fr/i ){
		$lang = "eng";
	} elsif( $ENV{'HTTP_ACCEPT_LANGUAGE'} =~ /^de/i ){
		$lang = "de";
	} elsif( $ENV{'HTTP_ACCEPT_LANGUAGE'} =~ /^zh-(cn|sg)/i ){
		$lang = "gb";
	} elsif( $ENV{'HTTP_ACCEPT_LANGUAGE'} =~ /^zh-(hk|tw)/i ){
		$lang = "big5";
	} else {
		$lang = "eng";
	}
} else {
	$lang = $fields{'lang'};
}

if( $fields{'step'} == 1 ){
	if( $fields{'eng.x'} || $fields{'eng.y'} ){ $lang = "eng"; }
	elsif( $fields{'fr.x'} || $fields{'fr.y'} ){ $lang = "fr"; }
	elsif( $fields{'de.x'} || $fields{'de.y'} ){ $lang = "de"; }
	elsif( $fields{'gb.x'} || $fields{'gb.y'} ){ $lang = "gb"; }
	elsif( $fields{'big5.x'} || $fields{'big5.y'} ){ $lang = "big5"; }
}

$langsub = { 'eng' => 0, 'fr' => 1, 'de' => 2, 'gb' => 3, 'big5' => 4 }->{$lang};

$pssurl = "http://www.perlstudio.de/forum"; $buildnum = "0420";
$pssroot = "http://www.perlstudio.de";

$header = qq{
<!doctype html public "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-type" content="text/html; charset=$charsets{$lang}">
<title>Forum Engine 2000 Setup</title>
<link rel="stylesheet" href="$pssurl/fe.css">
</head>
<body>
<form method="post" action="setup.cgi" onSubmit="return validate( this );">
<center>
<table cellspacing=0 cellpadding=0 width="450">
<tr>
	<td><img src="$pssurl/img/fe2000welcome.jpg" height=84 width=450></td>
</tr>
<tr>
};

$footer = qq{
</tr>
</table>
<table border=0 cellspacing=0 cellpadding=0 width="450">
</center>
<center>
<tr>
	<td background="$pssurl/img/barbg.gif"><img src="$pssurl/img/clear.gif" border=0 height=8 width=12></td>
</tr>
</center>
</table>
</form>
</body>
</html>
};

@steps = ( \&step0, \&step1, \&step2, \&step3, \&step4, \&step5 );

$fields{'step'} ||= "0";

if( $fields{'step'} <= 5 ){
	print "\n", $header;
	eval{
		&{$steps[$fields{'step'}]};
	};
	print $@;
	print $footer;
	exit;
}
#debug
tie( %users, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
@mydata = split( /\t/, $users{'1'} );
@mydata[4..17] = (
	$fields{'firstname'}, $fields{'lastname'}, $fields{'midinit'}, $fields{'suffix'},
	$fields{'gender'}, $mydata[9], $fields{'streetln1'}, $fields{'streetln2'}, $fields{'city'},
	$fields{'state'}, $fields{'zip'}, $fields{'country'}, $mydata[16], $fields{'emailsign'}
);
if( $fields{'preformatted'} ){
	$mydata[17] = "<pre>" . $mydata[17] . "</pre>";
}
$users{'1'} = join( "\t", @mydata );
untie %users;

print "Location: index.cgi\n\n";
exit;

sub step0 {
	print <<FORM;
<td bgcolor="#3232D8">
<input type="hidden" name="step" value="1">
<table cellpadding=0 width="100%" cellspacing=1>
<tr>
	<td valign=middle bgcolor="#FFFFFF" height="120" colspan="2">
<script language="JavaScript">
var errs = new Array(
	"You can't install this software if you don't accept the agreement.",
	"Vous ne pouvez pas installer ce logiciel si vous ne recevez pas l'accord.",
	"Sie konnen nicht diese Software installieren, wenn Sie nicht die Vereinbarung annehmen.",
	"ͬⱾЭ飬ܰװ",
	"zYPNĳANw˥nC" );
var langsub = 0;
function validate( frm ){
	if( frm.accept.checked == false ){
		alert( errs[langsub] );
		return false;
	}
	return true;
}
</script>
	&nbsp;<b>Forum Engine 2000 Setup</b><br><center>
	<textarea name="agreement" cols=40 rows=8 wrap="virtual">

AGREEMENT
-----------------------------------

We have been writting the codes very carefully and we did everything in good faith. However, there is no guarantee of any kind. Please read the following agreement carefully, then click on the buttons at the right to proceed. Before doing so you should indicate that you agree with these statements by check the box below.

NO WARRANT. You use the programs (including scripts and all other files if present) at your own risk. There is no guarantee of any kind. The author doesn't warrant the codes and the functions are free of error or defect. In no case should the author be held responsive to the damages including, but not confined to, lost of profit, lost of data, business interruption, investigation fee, and attorney fee, resulted by the use, misuse, or inability to use any part of this package. Any liability of us will be limited exclusively to the refund of purchase price. 

YOUR RIGHT. Registration for enterprise use grants you the right to run the software on one site (one domain) for unlimited copies. Registration for personal use grants you the right to run it on all your personal homepages for unlimited copies. You will receive bug reports and newsletter from us. The customer service and technical support will stay available for a timely service.

COPYRIGHT. The author holds the copyright of all source code of the products seen on this site. You can modify them to fit your site and needs, but in no case could you resell the original or derivative work of the programs. However, we do not require you to place a link to us or our copyright information on your board.

ENTIRE STATEMENT. You accept the entire statement of this agreement.

PRIVACY STATEMENT
-----------------------------------

You have been assigned a number for this operation, shown at the bottom in this form. This number is only assoicated with your current IP address. We recorded your browser information and current time in our database. These are the only information we recorded; no any other information you will be filling out in subsequent steps would be sent to the server.

	</textarea></center><br>&nbsp;
	<input type="Checkbox" name="accept" value="1"> I accept the agreement.
	</td>
	<td valign="bottom" rowspan="2" bgcolor="#FFFFFF">
	<img SRC="$pssurl/img/navnext.gif" HSPACE=2 VSPACE=2 height=16 width=16> <input type="Image" name="eng" SRC="$pssurl/img/langeng.gif" HSPACE=2 VSPACE=2 height=14 width=41 border=0 onClick="langsub=0"></a>
	<br><img SRC="$pssurl/img/navnext.gif" HSPACE=2 VSPACE=2 height=16 width=16> <input type="Image" name="fr" SRC="$pssurl/img/langfr.gif" HSPACE=2 VSPACE=2 height=14 width=47 border=0 onClick="langsub=1;"></a>
	<br><img SRC="$pssurl/img/navnext.gif" HSPACE=2 VSPACE=2 height=16 width=16> <input type="Image" name="de" SRC="$pssurl/img/langde.gif" HSPACE=2 VSPACE=2 height=14 width=47 border=0 onClick="langsub=2;"></a>
	<br><img SRC="$pssurl/img/navnext.gif" HSPACE=2 VSPACE=2 height=16 width=16> <input type="Image" name="gb" SRC="$pssurl/img/langgb.gif" HSPACE=2 VSPACE=2 height=14 width=35 border=0 onClick="langsub=3;"></a>
	<br><img SRC="$pssurl/img/navnext.gif" HSPACE=2 VSPACE=2 height=16 width=16> <input type="Image" name="big5" SRC="$pssurl/img/langbig5.gif" HSPACE=2 VSPACE=2 height=14 width=35 border=0 onClick="langsub=4;"></a>
	</td>
</tr>
<tr>
	<td BGCOLOR="#2020D8" width=150>
	<img SRC="$pssurl/img/psslogo.gif" BORDER=0 height=60 width=150 align="left" hspace=0 vspace=0>
	</td>
	<td BGCOLOR="#FFFFFF" valign="bottom" align="left">&nbsp;
	<img src="$pssroot/cgi-bin/fe2kcount.cgi?0" width=7 height=14 border=0><img src="$pssroot/cgi-bin/fe2kcount.cgi?1" width=7 height=14 border=0><img src="$pssroot/cgi-bin/fe2kcount.cgi?2" width=7 height=14 border=0><img src="$pssroot/cgi-bin/fe2kcount.cgi?3" width=7 height=14 border=0><img src="$pssroot/cgi-bin/fe2kcount.cgi?4" width=7 height=14 border=0><img src="$pssroot/cgi-bin/fe2kcount.cgi?5" width=7 height=14 border=0><br>&nbsp;
	<small>(C) 2000 PerlStudio.de</small><br>&nbsp;<small>All rights reserved</small>
	</td>
</tr>
</table>
</td>
FORM
}

sub step1 {
#debug
# Now create the error message database as the first step.
%errmsgeng = (
	'BLOCKED_IP' => qq{You are trying to post from an IP address that has been regarded unfriendly so can't proceed.},
	'FILE_NOT_EXIST' => qq{The message or forum you are trying to use does not exist.},
	'HAVE_SUBSCRIBED' => qq{You have already subscribed to this forum topic.},
	'HTTP_REF' => qq{This cgi program can not be called from outside the valid domains.},
	'INVALID_EMAIL' => qq{You appear to have entered an invalid email address. Please correct it and try again.},
	'INVALID_PWD' => qq{You can only use letters a through z or digits 0 through 9 in the password. Please try again.},
	'INVALID_SESS' => qq{The session you've attempted to access does not exist.},
	'INVALID_USER' => qq{You do not seem to be a valid registered user. Please check your nickname and password.},
	'NAME_OCCUPIED' => qq{The user name you chose has already been assigned to another user. Please choose a new one.},
	'NO_CONTENT' => qq{The title and content fields can not be both vacant.},
	'NO_PATTERN' => qq{You appear to have indicated an incorrect search pattern.},
	'NOT_EMPTY' => qq{The forum has sub-level forums so can't be removed.},
	'NOT_REGISTERED' => qq{You're not a registered user to complete this operation.},
	'NOT_SUBSCRIBED' => qq{You are not subscribed to this forum topic.},
	'PASSWD_MISMATCH' => qq{The password you've entered doesn't match the record.},
	'PWD_NOT_EQ' => qq{You should type an identical password twice in the previous screen in order to register successfully. Please check the spelling and try again.},
	'PWD_TOO_SHORT' => qq{The password you chose was too short. For your protection, you need to select a password consisted of at least four letters or digits.},
	'REGISTERED' => qq{Seems that you have registered before. Your record will be maintained so you don't have to register again.},
	'SESS_EXPIRED' => qq{The session has expired due to time out.},
	'USER_BANNED' => qq{Sorry, you're prohibited from posting new messages and any other operations.},
	'INVALID_UNAME' => qq{The user name you chose is invalid. Please use only use letters a through z or digits 0 through 9. User names are case-insensitive.},
	'FILL_REQ_FIELD' => qq{Please fill in all required fields.},
	'EMAIL_USED' => qq{The email address has been used for user registration.},
	'DISPNAME_USED' => qq{The display name has been used by another user.},
	'SUSP_LOGON' => qq{Suspicious username and / or password.},
);

%errmsgfr = (
	'BLOCKED_IP' => qq{Vous acc&eacute;dez d'une adresse qui a &eacute;t&eacute; peu amicale consid&eacute;r&eacute; ainsi ne pouvez pas proc&eacute;der.},
	'FILE_NOT_EXIST' => qq{Le message ou le forum que vous essayez d'utiliser n'existe pas.},
	'HAVE_SUBSCRIBED' => qq{Vous avez d&eacute;j&agrave; souscrit &agrave; ce sujet de forum.},
	'HTTP_REF' => qq{Ce programme CGI ne peut &ecirc;tre appel&eacute; de l'ext&eacute;rieur du domaine.},
	'INVALID_EMAIL' => qq{Le Courriel propos&eacute; est invalide. S.V.P. corriger et essayer de nouveau.},
	'INVALID_PWD' => qq{D&eacute;sol&eacute;s, seuls l\'alphabet de a &agrave; z et les chiffres de 0 &agrave; 9 sont permis dans la composition du mot de passe. Essayez de nouveau.},
	'INVALID_SESS' => qq{La session que vous avez essay&eacute; d'acc&eacute;der n'existe pas.},
	'INVALID_USER' => qq{Vous semblez ne pas &ecirc;tre sur la liste de nos membres inscrits. S.V.P. v&eacute;rifiez votre surnom et mot de passe et assurez-vous qu'ils ne contiennent pas de caract&egrave;res sp&eacute;ciaux ou de fautes d'orthographe.},
	'NAME_OCCUPIED' => qq{Le surnom choisi est d&eacute;j&agrave; utilis&eacute;. S.V.P. en choisir un autre et essayer de nouveau.},
	'NO_CONTENT' => qq{Les bo&icirc;tes &quot;sujet&quot; et &quot;message&quot; ne peuvent &ecirc;tre vides en m&ecirc;me temps.},
	'NO_PATTERN' => qq{Il semble que vos indications pour la recherche soient erron&eacute;es.},
	'NOT_EMPTY' => qq{Le forum a des sujets ne peut pas donc &ecirc;tre retir&eacute;.},
	'NOT_REGISTERED' => qq{Vous n'&ecirc;tes pas un utilisateur registre pour terminer cette ex&eacute;cution.},
	'NOT_SUBSCRIBED' => qq{Vous n'&ecirc;tes pas souscrits &agrave; ce sujet de forum.},
	'PASSWD_MISMATCH' => qq{Mot de passe non valide. V&eacute;rifiez en l'orthographe.},
	'PWD_NOT_EQ' => qq{Vous devez taper le m&ecirc;me mot de passe deux fois dans la page pr&eacute;c&eacute;dente pour r&eacute;ussir votre inscription. S.V.P. v&eacute;rifier l'orthographe et essayer de nouveau.},
	'PWD_TOO_SHORT' => qq{Votre mot de passe &eacute;tait trop court. Pour votre protection, composez votre mot de passe avec une combinaison d'au moins six lettres ou chiffres.},
	'REGISTERED' => qq{Il semble que vous vous soyez d&eacute;j&agrave; inscrit. Vos coordonn&eacute;es d'enregistrement seront retenues de fa?on &agrave; vous &eacute;viter de vous inscrire &agrave; nouveau.},
	'SESS_EXPIRED' => qq{Le temps allou&eacute; pour votre derni&egrave;re session est p&eacute;rim&eacute;. S.V.P. entrer de nouveau.},
	'USER_BANNED' => qq{Vous &ecirc;tes interdits de signaler de nouveaux messages et toutes les autres ex&eacute;cutions.},
	'INVALID_UNAME' => qq{Le nom d'utilisateur que vous avez choisi est incorrect. Veuillez utiliser seulement les lettres d'utilisation a  z ou  chiffres 0  9. Les noms d'utilisateur sont cas-peu sensibles.},
	'FILL_REQ_FIELD' => qq{Veuillez complter toutes les zones requises.},
	'EMAIL_USED' => qq{Le email address a t utilis pour l'enregistrement d'utilisateur.},
	'DISPNAME_USED' => qq{Le nom d'affichage a t employ par un autre utilisateur.},
	'SUSP_LOGON' => qq{Nom et/ou mot de passe souponneux d'utilisateur.},
);

%errmsgde = (
	'BLOCKED_IP' => qq{Sie versuchen, von einem IP Adresse bekanntzugeben, das betrachtetes unfreundliches gewesen ist, also k&ouml;nnen nicht fortfahren.},
	'FILE_NOT_EXIST' => qq{Die Meldung oder das Forum, die Sie versuchen zu benutzen, existierent nicht.},
	'HAVE_SUBSCRIBED' => qq{Sie haben bereits zu diesem Forumthema unterzeichnet.},
	'HTTP_REF' => qq{Dieses CGI-Programm kann nicht au&szlig;erhalb von den g&uuml;ltigen Gebieten benannt werden.},
	'INVALID_EMAIL' => qq{Sie scheinen, ein unzul&auml;ssiges email address eingetragen zu haben. Beheben Sie es bitte und versuchen Sie noch einmal.},
	'INVALID_PWD' => qq{Sie k&ouml;nnen Zeichen a bis z oder Digits 0 bis 9 nur benutzen im Kennwort. Bitte Versuch wieder.},
	'INVALID_SESS' => qq{Die Sitzung, die Sie versucht haben zuzugreifen, existierent nicht.},
	'INVALID_USER' => qq{Sie scheinen nicht, ein g&uuml;ltiger zugelassener Benutzer zu sein. &Uuml;berpr&uuml;fen Sie bitte Ihren Nickname und Kennwort.},
	'NAME_OCCUPIED' => qq{Der Benutzername, den Sie w&auml;hlten, ist bereits einem anderen Benutzer zugeordnet worden. W&auml;len Sie bitte ein Neues.},
	'NO_CONTENT' => qq{Die Name- und Inhaltsfelder k?nnen nicht freie beide sein.},
	'NO_PATTERN' => qq{Sie scheinen, ein falsches Suchmuster angezeigt zu haben.},
	'NOT_EMPTY' => qq{Das Forum hat Themen kann nicht folglich gel&ouml;scht werden.},
	'NOT_REGISTERED' => qq{Sie sind nicht ein zugelassener Benutzer zum Durchf&uuml;hren dieser Operation.},
	'NOT_SUBSCRIBED' => qq{Sie werden nicht zu diesem Forumthema unterzeichnet.},
	'PASSWD_MISMATCH' => qq{Das Kennwort, das Sie eingetragen haben, bringt nicht den Satz zusammen.},
	'PWD_NOT_EQ' => qq{Sie sollten ein identisches Kennwort auf dem vorhergehenden Bildschirm zweimal schreiben, um erfolgreich zu registrieren. &Uuml;berpr&uuml;fen Sie bitte den Spelling und versuchen Sie noch einmal.},
	'PWD_TOO_SHORT' => qq{Das Kennwort, das Sie w?hlten, war zu kurz.},
	'REGISTERED' => qq{Scheint, da&szlig; Sie vorher registriert haben. Ihr Satz wird beibehalten, also m&uuml;ssen Sie nicht wieder registrieren.},
	'SESS_EXPIRED' => qq{Die Sitzung hat abgelaufenes wegen der Zeit heraus.},
	'USER_BANNED' => qq{Traurig, werden Sie die Eintragung der neuen Meldungen und aller m&ouml;glicher anderen Operationen untersagt.},
	'INVALID_UNAME' => qq{Der Benutzername, den Sie whlten, ist unzulssig.  Benutzen Sie bitte nur Gebrauchzeichen a bis z oder Digits 0 bis 9.  Benutzernamen sind Schachtel-unempfindlich.},
	'FILL_REQ_FIELD' => qq{Fllen Sie bitte alle angeforderten Felder aus.},
	'EMAIL_USED' => qq{Das email address ist fr Benutzerausrichtung verwendet worden.},
	'DISPNAME_USED' => qq{Der Bildschirmanzeigename ist von einem anderen Benutzer verwendet worden.},
	'SUSP_LOGON' => qq{Mitrauischer Benutzername und/oder kennwort.},
);

%errmsggb = (
	'BLOCKED_IP' => qq{IPַֹ},
	'FILE_NOT_EXIST' => qq{ָҲ},
	'HAVE_SUBSCRIBED' => qq{Ѿ},
	'HTTP_REF' => qq{ֻܴӺϷַʡ},
	'INVALID_EMAIL' => qq{ʼַʽȷ},
	'INVALID_PWD' => qq{ѡȷʹa-z0-9ַ},
	'INVALID_SESS' => qq{ĵǰûм¼޸˵ַеĲȻٴ޸ġ},
	'INVALID_USER' => qq{Ǳ̳ʽǼû},
	'NAME_OCCUPIED' => qq{ѡõûѾռãѡ},
	'NO_CONTENT' => qq{ܶţܵдʲôɡ},
	'NO_PATTERN' => qq{Ҫҵݲ},
	'NOT_EMPTY' => qq{ǰ¼飬޷ɾ},
	'NOT_REGISTERED' => qq{δעΪʽûܽд},
	'NOT_SUBSCRIBED' => qq{δһ},
	'PASSWD_MISMATCH' => qq{벻ԡ},
	'PWD_NOT_EQ' => qq{벻һ£顣},
	'PWD_TOO_SHORT' => qq{̫̣ĸĸ֡},
	'REGISTERED' => qq{ѾǼǹˡ},
	'SESS_EXPIRED' => qq{ĵǰ̳ʱ¼Ѿɾٴε¼},
	'USER_BANNED' => qq{Բʺʱֹκβ},
	'INVALID_UNAME' => qq{ѡûǷַʹӢĸ֡},
	'FILL_REQ_FIELD' => qq{дȫѡ},
	'EMAIL_USED' => qq{ʼַѾעˡ},
	'DISPNAME_USED' => qq{ĻǳѾˡ},
	'SUSP_LOGON' => qq{ûʽԡ},
);

%errmsgbig5 = (
	'BLOCKED_IP' => qq{zIPa\}QT[KC},
	'FILE_NOT_EXIST' => qq{zwQײթΩl䤣C},
	'HAVE_SUBSCRIBED' => qq~zwgq\\FoӰQײժl~,
	'HTTP_REF' => qq{\{ǰNqXka\}XݡC},
	'INVALID_EMAIL' => qq{qlla\}榡̡C},
	'INVALID_PWD' => qq{KXw̡AШϥa-z0-9ršC},
	'INVALID_SESS' => qq~zei\{SOCγ\\zקFa\}椤ѼơAYMAФŦAקC~,
	'INVALID_USER' => qq{zO׾ªnOΤC},
	'NAME_OCCUPIED' => qq{zҿΪΤWwgQeΡAЭsܡC},
	'NO_CONTENT' => qq{DMe椣ೣŵۡA`ogI\aC},
	'NO_PATTERN' => qq{nd䪺eXzC},
	'NOT_EMPTY' => qq~eQײզsbUŤաALkRC~,
	'NOT_REGISTERED' => qq~z٥`UΤAi榹ާ\@C~,
	'NOT_SUBSCRIBED' => qq~z\}q\\o\@Qײժl~,
	'PASSWD_MISMATCH' => qq~zJKXC~,
	'PWD_NOT_EQ' => qq{KX\@PAˬdC},
	'PWD_TOO_SHORT' => qq{KXӵuAгֿ̤J|ӦrμƦrC},
	'REGISTERED' => qq{zwgnOLFC},
	'SESS_EXPIRED' => qq~zei{WɡAOwgRAЦAnC~,
	'USER_BANNED' => qq~藍_AzbȮɳQTiާ\@C~,
	'INVALID_UNAME' => qq{z諸ΤW]tDkršCШϥέ^rμƦrC},
	'FILL_REQ_FIELD' => qq{жgﶵC},
	'EMAIL_USED' => qq~qlla}wgQ`ULFC~,
	'DISPNAME_USED' => qq{̹٤wgHΤFC},
	'SUSP_LOGON' => qq{ΤWαKX榡C},
);

tie( %msg, $DB_Type, "dat/errmsg", &GDBM_WRCREAT, 0666 );
$msg{'langs'} = "eng	fr	de	gb	big5";
foreach $ky (keys %errmsgeng){
	$msg{$ky} = join("\t", $errmsgeng{$ky}, $errmsgfr{$ky}, $errmsgde{$ky}, $errmsggb{$ky}, $errmsgbig5{$ky});
}
untie %msg;
#cut
if( -e "bbs.cfg" ){
	$FL_overlookreferer = 1;
	require "bbs.cfg";
	if( open( USERLIST, "<$datadir/userlist.cgi" ) ){
		while( <USERLIST> ){
			last if( /^webmaster/ );
		}
		my @mydata = split( /\t/ );
		$password = $mydata[1];
		close( USERLIST );
	} elsif( open( USERLIST, "<$datadir/pwdlist.cgi" ) ){
		while( <USERLIST> ){
			last if( /^webmaster/ );
		}
		my @mydata = split( /=/ );
		$password = $mydata[1];
		close( USERLIST );
	}
} else {
	$webmaster = $ENV{'SERVER_ADMIN'};
}

%msgs = (
'title' => [
	qq{Step 1: Log-in information},
	qq{&Eacute;tape 1: L'information de log-in},
	qq{Jobstep 1: Logon-Informationen},
	qq{һ¼Ϣ},
	qq{Ĥ\@BGnH},
	],
'welcome' => [
	qq{Thank you for chosing Forum Engine 2000!	Your user name is <b>webmaster</b>. Please fill in the fields below. Fields marked with a <img src="$pssurl/img/marknote.gif" width=10 height=10> are required.},
	qq{Merci pour l'usage du Forum Engine 2000! Votre nom d'utilisateur est <b>webmaster</b>. Veuillez compl&eacute;ter les zones ci-dessous. Des zones identifi&eacute;es par une <img src="$pssurl/img/marknote.gif" width=10 height=10> sont exig&eacute;es.},
	qq{Danke f&uuml;r das Verwenden Forum Engine 2000! Ihr Benutzername ist <b>webmaster</b>. F&uuml;llen Sie bitte die Felder unten aus. Die Felder, die mit einem <img src="$pssurl/img/marknote.gif" width=10 height=10> gekennzeichnet werden, werden angefordert.},
	qq{ллѡ̳2000ĵ¼ǡwebmasterдݣ <img src="$pssurl/img/marknote.gif" width=10 height=10> ΪϢ},
	qq{±zν׾¤2000IznWOwebmasterCжgHUuAa <img src="$pssurl/img/marknote.gif" width=10 height=10> ̬HC },
	],
'passwd' => [
	qq{Password},
	qq{Mot de passe},
	qq{Kennwort},
	qq{},
	qq{KX},
	],
'passwdver' => [
	qq{Type again},
	qq{Encore},
	qq{Art wieder},
	qq{һȷ},
	qq{`\@M},
	],
'explain' => [
	qq{The password has to be at least five letters long, consisting only a-z or 0-9 and no spaces. If you have previous version installed, it's likely the fields have been filled out for you.},
	qq{Le mot de passe doit tre au moins cinq lettres longues, consistant seulement a-z ou 0-9 et aucuns espaces. Si vous avez la version prcdente install, il est probable les zones ont t complts pour vous.},
	qq{Das Kennwort mu mindestens fnf Zeichen sein, die lang sind und bestehen nur a-z oder 0-9 und keine Platz. Wenn Sie vorhergehende Version installiert haben, ist es die Felder ist gefllt worden heraus fr Sie wahrscheinlich.},
	qq{ĸɣҲðոװ˱ľɰ汾ݿѾڵϢ},
	qq{KXѦܤ֤ӦrμƦrզA\}Bo]tŮCpGzwˤFnªA檺uiwgnF\{bHC},
	],
'displayname' => [
	qq{Display name},
	qq{Nom d'affichage},
	qq{Bildschirmanzeigename},
	qq{ʾ},
	qq{ܪWr},
	],
'email' => [
	qq{Email address},
	qq{Courriel},
	qq{Email},
	qq{ʼַ},
	qq~qlla\}~,
	],
'webmaster' => [
	qq{Webmaster},
	qq{Administrateur},
	qq{Verwalter},
	qq{},
	qq{},
	],
'errpwdshort' => [
	$errmsgeng{'PWD_TOO_SHORT'},
	$errmsgfr{'PWD_TOO_SHORT'},
	$errmsgde{'PWD_TOO_SHORT'},
	$errmsggb{'PWD_TOO_SHORT'},
	$errmsgbig5{'PWD_TOO_SHORT'},
	],
'errpwdnoteq' => [
	$errmsgeng{'PWD_NOT_EQ'},
	$errmsgfr{'PWD_NOT_EQ'},
	$errmsgde{'PWD_NOT_EQ'},
	$errmsggb{'PWD_NOT_EQ'},
	$errmsgbig5{'PWD_NOT_EQ'},
	],
'erremail' => [
	$errmsgeng{'INVALID_EMAIL'},
	$errmsgfr{'INVALID_EMAIL'},
	$errmsgde{'INVALID_EMAIL'},
	$errmsggb{'INVALID_EMAIL'},
	$errmsgbig5{'INVALID_EMAIL'},
	],
'nextstep' => [
	qq{Next step},
	qq{Prochaine &eacute;tape},
	qq{Folgender Jobstep},
	qq{һ},
	qq{U\@B},
	],
);
print <<FORM;
<td>
<script language="JavaScript">
function validate( frm ){
	if( frm.password.value.length < 4 ){
		alert( "$msgs{'errpwdshort'}[$langsub]" );
		return false;
	}
	if( frm.password.value != frm.passwdver.value ){
		alert( "$msgs{'errpwdnoteq'}[$langsub]" );
		return false;
	}
	if( !frm.email.value.match( /^\\S+\@(\\S+\\.)+\\S+\$/ ) ){
		alert( "$msgs{'erremail'}[$langsub]" );
		return false;
	}
	return true;
}
</script>
<input type="hidden" name="step" value="2">
<input type="hidden" name="lang" value="$lang">
<table border=0 cellspacing=0 cellpadding=0>
<tr>
	<td width=8><img src="$pssurl/img/tagleft.gif" width=8 height=16 border=0></td>
	<td background="$pssurl/img/tagbg.gif"><b>$msgs{'title'}[$langsub]</b></td>
	<td width=8><img src="$pssurl/img/tagright.gif" width=8 height=16 border=0></td>
</tr>
</table>
<table border=0 cellspacing=0 cellpadding=0 width="100%">
<tr>
	<td background="$pssurl/img/barbg.gif"><img src="$pssurl/img/clear.gif" border=0 height=8 width=12></td>
</tr>
</table>
</td>
</tr>
<tr>
<td bgcolor="#3232D8">
<table border=0 cellspacing=1 cellpadding=2 width="100%">
<tr>
	<td bgcolor="white" colspan=2>$msgs{'welcome'}[$langsub]</td>
</tr>
<tr>
	<td bgcolor="white" align=right>$msgs{'passwd'}[$langsub] (<u>P</u>)</td>
	<td bgcolor="white"><input type="Password" accesskey="p" name="password" size="12" value="$password" maxlength="30"> <img src="$pssurl/img/marknote.gif" height=10 width=10>&nbsp;&nbsp;
	$msgs{'passwdver'}[$langsub] <input type="Password" name="passwdver" size="12" value="$password" maxlength="30"><img src="$pssurl/img/marknote.gif" height=10 width=10><br>
	$msgs{'explain'}[$langsub]
</td>
</tr>
<tr>
	<td bgcolor="white" align=right>$msgs{'displayname'}[$langsub] (<u>D</u>)</td>
	<td bgcolor="white"><input type="Text" accesskey="d" name="displayname" size="12" maxlength="60" value="$msgs{'webmaster'}[$langsub]" vcard_name="vCard.LastName"> <img src="$pssurl/img/marknote.gif" width=10 height=10>
	</td>
</tr>
<tr>
	<td bgcolor="white" align=right>$msgs{'email'}[$langsub] (<u>M</u>)</td>
	<td bgcolor="white"><input type="Text" name="email" size="30" accesskey="m" maxlength="40" value="$webmaster" vcard_name="vCard.Email"> <img src="$pssurl/img/marknote.gif" width=10 height=10></td>
</tr>
<tr>
	<td bgcolor="white" align=right colspan=2>
	<input type="submit" value="&gt;&gt; $msgs{'nextstep'}[$langsub]">
	</td>
</tr>
</table>
</td>
FORM
}

sub step2 {
#debug

tie( %users, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
$users{'fields'} = 19;
$users{'f0'} = "username		N	1	1";
$users{'f1'} = "password		P	1	1";
$users{'f2'} = "permission			0	1";
$users{'f3'} = "displayname		D	1	1";
$users{'f4'} = "firstname	vCard.FirstName	F	1	2";
$users{'f5'} = "lastname	vCard.LastName	L	1	2";
$users{'f6'} = "midinit	vCard.Middlename	T	0	2";
$users{'f7'} = "suffix	vCard.Suffix	X	0	2";
$users{'f8'} = "sex			0	2";
$users{'f9'} = "email	vCard.Email	M	1	2";
$users{'f10'} = "streetln1	vCard.Home.StreetAddress	R	0	2";
$users{'f11'} = "streetln2			0	2";
$users{'f12'} = "city	vCard.Home.City	Y	0	2";
$users{'f13'} = "state	vCard.Home.State	S	0	2";
$users{'f14'} = "zip	vCard.Home.Zipcode	Z	0	2";
$users{'f15'} = "country	vCard.Home.Country	U	0	2";
$users{'f16'} = "langpref			0	3";
$users{'f17'} = "emailsign			0	3";
$users{'f18'} = "timezone			0	3";
$users{'0'} = join( "\t", "", "", 0, "\t" x 15 );	# For guest AND the program itself
my @tmparray = ( "webmaster", $fields{'password'}, 6, $fields{'displayname'} );
@tmparray[4..18] = ( "" ) x 15;
$tmparray[9] = $fields{'email'};
$users{'1'} = join( "\t", @tmparray );
# This is part of the initialization. Will do more later in other steps.
$users{'numusers'} = 1;
$users{'nextuserid'} = 2;
untie %users;
tie( %settings, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
$settings{'buildnum'} = $buildnum;
$settings{'setuptime'} = time;
$settings{'webmaster'} = $fields{'email'};
untie %settings;
#cut
%msgs = (
'title' => [
	qq{Step 2: Localization},
	qq{&Eacute;tape 2: L'information de log-in},
	qq{Jobstep 2: Logon-Informationen},
	qq{ڶػ},
	qq{ĤGBGa},
	],
'lang' => [
	qq{Language},
	qq{Language},
	qq{Sprache},
	qq{},
	qq{y },
	],
'langprompt' => [
	qq{This software comes with five languages. Please check all those you want to provide for your users. Use Shift and Control keys to make multiple choices.},
	qq{Ce logiciel vient avec cinq langages. Veuillez contrler tout ceux que vous voulez fournir pour vos utilisateurs. Vous pouvez rendre des choix simples ou multiples.},
	qq{Diese Software kommt mit fnf Sprachen. berprfen Sie bitte alles die, die Sie fr Ihre Benutzer zur Verfgung stellen mchten. Sie knnen einzelne oder mehrfache bilden entweder Wahlen.},
	qq{ڽ֧ԣѡҪṩûԣʹShiftControlжѡ},
	qq{n󤺫ؤyAпܱzQnѵΤ᪺yAϥShiftMControlihܡC},
	],
'hidelangbuttons' => [
	qq{Do not show language buttons.},
	qq{Ne montrez pas les boutons de langage.},
	qq{Zeigen nicht Sprachtasten.},
	qq{ʾлť},
	qq~ܻysC~,
	],
'eng' => [
	qq{English},
	qq{Anglais},
	qq{Englisch},
	qq{Ӣ},
	qq{^y},
	],
'fr' => [
	qq{French},
	qq{Fran&ccedil;ais},
	qq{Franzsisch},
	qq{},
	qq{ky},
	],
'de' => [
	qq{German},
	qq{Allemand},
	qq{Deutsch},
	qq{},
	qq{wy},
	],
'gb' => [
	qq{Simplified Chinese},
	qq{Chinois Simplifi},
	qq{Vereinfachter Chinese},
	qq{},
	qq{²^},
	],
'big5' => [
	qq{Traditional Chinese},
	qq{Chinois Traditionnel},
	qq{Traditioneller Chinese},
	qq{},
	qq{c^},
	],
'langpref' => [
	qq{Please also speficy the default language},
	qq{S'il vous plat aussi speficy le langage de dfaut.},
	qq{Bitte auch speficy die Rckstellung Sprache.},
	qq{ָѡԡ},
	qq{Ыw諸yC},
	],
'timezone' => [
	qq{Time zones},
	qq{Fuseau horaire},
	qq{Zeitzone},
	qq{ʱ},
	qq{ɰ},
	],
'servers' => [
	qq{Server's},
	qq{Serveur},
	qq{Systemserver},
	qq{},
	qq{AȾ},
	],
'yours' => [
	qq{Yours},
	qq{Vous},
	qq{Ihre},
	qq{ıػ},
	qq{za},
	],
'warning' => [
	qq{The program has tried to find out the timezones for you. Please check to see if they are correct.},
	qq{Le programme a essay de dcouvrir les fuseaux horaires pour vous. Contrlez s'il vous plat pour voir s'ils sont corrects.},
	qq{Das Programm hat versucht, die Zeitzonen fr Sie herauszufinden. berprfen Sie bitte, um zu sehen, wenn sie korrekt sind.},
	qq{ķõĻֱʱǷȷ},
	qq{zAȾMz\{bҥΪ󾹤ObpUɰϡAˬdO_̡C},
	],
'erroutofrange' => [
	qq{The default language is not selected as a provided language.},
	qq{Le langage de dfaut n'est pas choisi comme langage fourni.},
	qq{Die Rckstellung Sprache wird nicht als zur Verfgung gestellte Sprache ausgewhlt.},
	qq{ȱʡѡûаṩ棬},
	qq{ʬ٪yܨS]AbѪyW樽A},
	],
'nextstep' => [
	qq{Next step},
	qq{Prochaine &eacute;tape},
	qq{Folgender Jobstep},
	qq{һ},
	qq{U\@B},
	],
);
print <<FORM;
<td>
<script language="JavaScript">
var idx = 0;
function validate( frm ){
	if( frm.provlangs.options[ idx ].selected == false ){
		alert( "$msgs{'erroutofrange'}[$langsub]" );
		return false;
	}
	return true;
}
</script>
<input type="hidden" name="step" value="3">
<input type="hidden" name="lang" value="$lang">
<table border=0 cellspacing=0 cellpadding=0>
<tr>
	<td width=8><img src="$pssurl/img/tagleft.gif" width=8 height=16 border=0></td>
	<td background="$pssurl/img/tagbg.gif"><b>$msgs{'title'}[$langsub]</b></td>
	<td width=8><img src="$pssurl/img/tagright.gif" width=8 height=16 border=0></td>
</tr>
</table>
<table border=0 cellspacing=0 cellpadding=0 width="100%">
<tr>
	<td background="$pssurl/img/barbg.gif"><img src="$pssurl/img/clear.gif" border=0 height=8 width=12></td>
</tr>
</table>
</td>
</tr>
<tr>
<td bgcolor="#3232D8">
<table border=0 cellspacing=1 cellpadding=2 width="100%">
<tr>
	<td bgcolor="white" align=right valign=top>$msgs{'lang'}[$langsub]</td>
	<td bgcolor="white">
	$msgs{'langprompt'}[$langsub]<br><br>
	<select name="provlangs" multiple size=5>
	<option value="eng" selected>$msgs{'eng'}[$langsub]</option>
	<option value="fr" selected>$msgs{'fr'}[$langsub]</option>
	<option value="de" selected>$msgs{'de'}[$langsub]</option>
	<option value="gb" selected>$msgs{'gb'}[$langsub]</option>
	<option value="big5" selected>$msgs{'big5'}[$langsub]</option>
	</select>
	<hr size=1 color="\#2020D8" noshade>
	$msgs{'langpref'}[$langsub]<br>
	<input type="Radio" name="langpref" value="eng" checked onClick="idx=0;"> <img src="$pssurl/img/langeng.gif" width=41 height=14 border=0 alt="English">
	<input type="Radio" name="langpref" value="fr" onClick="idx=1;"> <img src="$pssurl/img/langfr.gif" width=47 height=14 border=0 alt="Fran&ccedil;ais">
	<input type="Radio" name="langpref" value="de" onClick="idx=2;"> <img src="$pssurl/img/langde.gif" width=47 height=14 border=0 alt="Deutsch">
	<input type="Radio" name="langpref" value="gb" onClick="idx=3;"> <img src="$pssurl/img/langgb.gif" width=35 height=14 border=0 alt="Simplified Chinese">
	<input type="Radio" name="langpref" value="big5" onClick="idx=4;"> <img src="$pssurl/img/langbig5.gif" width=35 height=14 border=0 alt="Traditional Chinese">
	<hr size=1 color="\#2020D8" noshade>
	<input type="Checkbox" name="hidelangbuttons" value="1" unchecked> $msgs{'hidelangbuttons'}[$langsub]
	</td>
</tr>
<tr>
	<td bgcolor="white" align=right>$msgs{'timezone'}[$langsub]</td>
	<td bgcolor="white">
	$msgs{'warning'}[$langsub]<br>
	$msgs{'servers'}[$langsub] <select name="timezone">
FORM

use Time::Local;
my @tt = localtime( time );
splice( @tt, 6 );
$servtimezone = ( timegm( @tt ) - timelocal( @tt ) ) / 3600;
for( $tz = -12; $tz <=12 ; $tz++ ){
	my $isselected = ( $servtimezone == $tz )? "selected": "";
	print qq{
		<option value="$tz" $isselected>$tz</option>
	};
}
print qq{
	</select>
	$msgs{'yours'}[$langsub]
	<select name="mytimezone">
};
for( $tz = -12; $tz <=12 ; $tz++ ){
	print qq{
		<option value="$tz">$tz</option>
	};
}
print qq{
	</select>
	</td>
</tr>
<tr>
	<td bgcolor="white" align=right colspan=2>
	<input type="submit" value="&gt;&gt; $msgs{'nextstep'}[$langsub]">
	</td>
</tr>
</table>
</td>
<script language="JavaScript">
var mytime = new Date( );
var mytz = Math.round( mytime.getTimezoneOffset( ) / 60 );
document.forms[0].mytimezone.options[ 12 - mytz ].selected = true;
</script>
};
}

sub step3 {
#debug
@dictterms = (
qq~all\tAll\tTout\tAlles\tȫ\t~,
qq~appsign\tAppend my email signature.\tAjoutez mon signature d'email.\tAppend my email signature.\tӸǩ\t[ӤHñW~,
qq~apr\tApr\tavril\tApril\t\t|~,
qq~aug\tAug\tao&ucirc;t\tAugust\t\tK~,
qq~author\tAuthor\tAuteur\tAutor\t\t\@~,
qq~autoinform\tAuto Notification\tAvis automatique\tAutomatische Mitteilung\tԶ֪ͨ\t^۰ʳq~,
qq~banned\tBanned\tInterdit\tVerboten\tֹ\tT~,
qq~bubble\tMove upwards\tD&eacute;placez vers le haut\tBewegung aufw&auml;rts\tϸ\tWB~,
qq~cancel\tForget it\tAnnulent\tBeenden\t\tF~,
qq~ccself\tSend a copy of this message to my email account.\tEnvoyez une copie de ce message &agrave; mon compte d'email.\tSchicken Sie ein Exemplar dieser Meldung zu meinem emailkonto.\t׸屸ҵ\tZƥeܧڪlc~,
qq~city\tCity\tVille\tStadt\t\t~,
qq~cleanbin\tClean up recycle bin\tEffacez tous les enregistrements\tL&auml;schen Sie alle S&auml;tze\tջվ\tMŦ^~,
qq~contactinfo\tContact info\tL'information de contact\tKontaktinformationen\tϵ\tptk~,
qq~country\tCountry\tPays\tLand\t\ta~,
qq~create\tCreate\tCr&eacute;ent\tErstellen\t\tЫ~,
qq~date\tDate\tDate\tDatum\t\t~,
qq~dec\tDec\td&eacute;cembre\tDezember\tʮ\tQG~,
qq~description\tDescription\tDescription\tBeschreibung\tҪ˵\t²n~,
qq~dictionary\tDictionary\tDictionnaire\tVerzeichnis\tֵ\tr~,
qq~displayname\tDisplay name\tNom d'affichage\tBildschirmanzeigename\tĻǳ\t̹~,
qq~edit\tEdit\t&Eacute;ditent\tBearbeiten\t༭\ts~,
qq~email\tEmail address\tCourriel\tEmail\tַ\tqllca}~,
qq~emailsign\tEmail signature\tSignature\tUnterschrift\tʼǩ\tlñW~,
qq~exit\tExit\tSortir\tBeenden\t˳\thX~,
qq~expall\tExpand all\tExpand all\tAusklappen\tȫչ\ti~,
qq~expired\tExpired\tExpir&eacute;\tAbgelaufen\tʱ\tW~,
qq~feb\tFeb\tf&eacute;vrier\tFebruar\t\tG~,
qq~female\tFemale\tFemelle\tFrau\tŮʿ\tk~,
qq~firstname\tFirst name\tPr&eacute;nom\tVorname\t\tjW~,
qq~firstpage\tFirst page\tFirst page\tErste Seite\tһҳ\tĤ\@~,
qq~foldall\tFold all\tFold all\tEinklappen\tȫ۵\t|~,
qq~followups\tFollow-ups\tR&eacute;ponses\tAntworten\t¼\tUŸK~,
qq~fri\tFri\tvendredi\tFreitag\t\tP~,
qq~gender\tGender\tGenre\tGeschlecht\tԱ\tʧO~,
qq~guest\tGuest\tInvit&eacute;\tGast\tÿ\tX~,
qq~hello\tHello!\tBonjour!\tWie geht's?\tã\tAnI~,
qq~help\tHelp\tAide\tHilfe\t\tU~,
qq~hits\tHits\tAcc&egrave;s\tBesucher\t\tXݼ~,
qq~home\tSite homepage\tAccueil\tZur Homepage\tҳ\tD~,
qq~id\tID number\tIdentification\tKennzeichen\tǼǺ\tnO~,
qq~index\tForum index\tIndex\tForum Index\tĿ¼\tؿ~,
qq~insert\tInsert\tintroduire\tEinfgen\t\tJ~,
qq~instantmsgr\tInstant Message\tMessage instant\tSofortige Meldung\tʱר\tɱMe~,
qq~ipaddr\tIP address\tl'adresse IP\tIP Adresse\tIPַ\tIPa}~,
qq~jan\tJan\tjanvier\tJanuar\tһ\t\@~,
qq~jul\tJul\tjuillet\tJuli\t\tC~,
qq~jun\tJun\tjuin\tJuni\t\t~,
qq~keepsecret\tKept secret\tSecret\tGeheime\t\tOK~,
qq~keywords\tKeywords\tCrit&egrave;re de recherche\tSuchbegriff\tؼ\t~,
qq~langpref\tPreferred language\tLangage pr&eacute;f&eacute;r&eacute;\tBevorzugte Sprache\tѡ\ty~,
qq~lastname\tLast name\tNom de famille\tFamilienname\t\tQm~,
qq~lastpage\tLast page\tLast page\tLetzte Seite\tĩβҳ\t~,
qq~left\tLeft\tC&ocirc;t&eacute; &agrave; gauche\tLinke Seite\t\t~,
qq~level\tLevel\tniveau\tEbene\t\th~,
qq~leveldec\t- 1 level\t- 1 level\t-1 Ebene\t۵һ\t|\@h~,
qq~levelinc\t+ 1 level\t+ 1 level\t-1 Ebene\tչһ\tiۤ\@h~,
qq~list\tList\tAffichage\tSuchen\tʾ\tCL~,
qq~lock\tLock\tVerrouillez\tSperren\tֹ\tT[K~,
qq~logininfo\tLog-in info\tLog-in info\tLog-in info\t¼Ϣ\tnk~,
qq~logon\tLog on\tEntrer\tAnmelden\t¼\tn~,
qq~logout\tLog out\tSortir\tAbmelden\t˳\thX~,
qq~lower\tLower level\tNiveau plus bas\tNiedrigere Ebene\t\tVU~,
qq~male\tMale\tM&acirc;le\tMann\t\tӭ~,
qq~manager\tManager\tGestionnaire\tManager\tԱ\t޲z~,
qq~mar\tMar\tmars\tM&auml;rz\t\tT~,
qq~marknote\tdenotes required fields.\td&eacute;note les zones requises.\tbezeichnet angeforderte Felder.\tϢ\tH~,
qq~matchall\tMatch all words.\tTrouvez tous les mots.\tFinden alle W&ouml;rter.\tȫؼ\t]t~,
qq~matchany\tMatch any words.\tTrouvez tous les mots possibles.\tFinden alle m&ouml;gliche W&ouml;rter.\tֹؼ\t]t~,
qq~matchcase\tMatch case.\tCaract&egrave;res identiques\tUnterscheiden sich Versalien und Kleinschreibung.\tСд\tjpgӷP~,
qq~matchexact\tExact phrase.\tExpression exacte.\tGenaue Phrase.\t\t]t~,
qq~may\tMay\tmai\tMai\t\t~,
qq~member\tMember\tMembre\tBauteil\tԱ\t|~,
qq~message\tMessage\tContenu\tMeldung Inhalt\t\te~,
qq~messages\tMessages\tMessages\tAntworten\t\tl~,
qq~midinit\tMiddle initial\tDeuxi&egrave;me pr&eacute;nom\tMittlerer Name\tм\tW~,
qq~moderator\tModerator\tmod&eacute;rateur\tModerator\tԱ\t޲z~,
qq~modified\tLast Modified\tMis&agrave;jour\tZuletzt gendert\t\țZs~,
qq~mon\tMon\tlundi\tMontag\tһ\tP\@~,
qq~movenode\tTree adjustment\tD&eacute;placez les messages\tVerschieben die Meldungen\tĿ¼\tؿվ~,
qq~newforum\tNew forum\tNouveaux forum\tNeue Foren\t½\tsذQײ~,
qq~next\tNext\tsuivant\tNchste\tһ\tU\@~,
qq~nextpage\tNext page\tsuivant\tNchste Seite\tһҳ\tU\@~,
qq~nocontent\tNo content\tAucun contenu\tkein Inhalt\t\tLe~,
qq~noinform\tCancel auto-notification\tAnnulez l'automobile-avis\tBeenden die Automobil-Mitteilung\tԶ֪ͨ\tM۰ʳq~,
qq~nomessage\tNo messages yet\tAucuns messages\tKeine Meldungen\tδ˼\t|H[K~,
qq~noreply\tDo not accept reply messages\tNe recevez pas les r&eacute;ponses.\tKeine Antworten werden angenommen.\tػظϢ\t^`hH~,
qq~nov\tNov\tnovembre\tNovember\tʮһ\tQ\@~,
qq~oct\tOct\toctobre\tOktober\tʮ\tQ~,
qq~options\tOptions\tOptions\tOptionen\tѡ\tﶵ~,
qq~page\tPage\tPage\tSeite\tҳ\t~,
qq~passwdver\tRepeat password\tR&eacute;p&eacute;tez le mot de passe\tRepeat password\tȷ\t̻{KX~,
qq~password\tPassword\tMot de passe\tKennwort\t\tKX~,
qq~permission\tPermission\tPermission\tErlaubnis\tȨ\tv~,
qq~plsregister\tNot a registered user? Sign up here!\tPas un utilisateur registre? Registre ici!\tNicht ein zugelassener Benutzer? Register hier!\tûڴ˵Ǽ\tsΤЦbnO~,
qq~poptopics\tPop Topics\tSujets populaires\tPopul&auml;re Themen\tŻ\tD~,
qq~post\tPost a new message\t&Eacute;crivez un nouveau message\tSchreiben eine neue Meldung\t\t[sK~,
qq~previous\tPrevious\tPr&eacute;c&eacute;dent\tVorig\tһ\tW\@~,
qq~prevpage\tPrevious page\tPage pr&eacute;c&eacute;dente\tSeite zurck\tǰһҳ\te\@~,
qq~print\tPrintable version\tImprimante-amical\tDrucken alle Meldungen\tӡ\tL~,
qq~reads\tReads\tLectures\tLeser\tĶ\t\\Ū~,
qq~recbin\tRecycle bin\tMessages retir&eacute;s\tAbfalldose\tվ\t^~,
qq~refresh\tRefresh\tRafra&icirc;chir\tNeuladen\tˢ\ts~,
qq~regset\tRegistration / preference settings\tConfigurations d'enregistrement / pr&eacute;f&eacute;rence\tAusrichtung / Pr&auml;ferenz Einstellungen\tǼǻĸ\tnOΧӤH]m~,
qq~relevance\tRelevance\tPertinence\tBedeutung\t\t~,
qq~remove\tRemove\tEffacer\tEntfernen\tɾ\tR~,
qq~removed\tRemoved\tRetir&eacute;\tGel&ouml;scht\tɾ\tR~,
qq~removefr\tRemove forum\tEnlevez le forum\tL&ouml;schen das Forum\tɾ\tRQײ~,
qq~reply\tReply\tR&eacute;ponse\tAntwort\t\tK~,
qq~right\tRight\tC&ocirc;t&eacute; droit\tRechte Seite\tұ\tk~,
qq~sat\tSat\tsamedi\tSamstag\t\tP~,
qq~search\tSearch\tRecherche\tSuchen\t\td~,
qq~searchres\tSearch results\tR&eacute;sultats\tResultate\tҽ\td䵲G~,
qq~send\tSend\tEnvoient\tSenden\t\toe~,
qq~sendmail\tSend me an email about replys.\tSi il y a r&eacute;ponse, enboyez un courriel.\tSchicken Sie mir ein email &uuml;ber replys.\tл뺯\t^YШi~,
qq~senior\tSenior\tA&icirc;n&eacute;\t&Auml;lterer\tرԱ\t`|~,
qq~sep\tSep\tseptembre\tSeptember\t\tE~,
qq~setup\tForum setup\tForum install&eacute;\tForum gr&uuml;ndete\t̳\t׾³]m~,
qq~settings\tCustomizing setting\tConfigurations\tEinstellungen anpassen\t\t]m~,
qq~sex\tGender\tGenre\tGeschlecht\tԱ\tʧO~,
qq~sink\tMove downwards\tDescendre\tBewegung abw&auml;rts\t³\tUI~,
qq~sortby\tSort by\tTri pas...\tSortierung bis...\t򷽷\tƧǤk~,
qq~state\tState/Province\tProvince\tZustand / Provinz\tʡ\t٥~,
qq~status\tStatus\tMode\tStatus\t״̬\tA~,
qq~streetln1\tStreet address\tAdresse\tSendenadresse\tͨѶַ\tqTa}~,
qq~streetln2\tStreet address contd.\tAdresse (continu&eacute;)\t(die zweite Zeile)\tַ\ta}\~~,
qq~subject\tDiscussion Subjects\tSujet\tDiskussionsthemen\t\tDD~,
qq~subscribe\tSubscribe\tS'abonner\tAbonnieren\t\tq\\\\~,
qq~subtopics\tSubtopics\tSujets sp&eacute;cifiques\tSpezifische Themen\t¼\tUŰQײ~,
qq~subunsub\tSubscription/Unsubscription\tSouscrivez ou annulez\tUnterzeichnen oder beenden\t/˶\tq\\hq~,
qq~suffix\tSuffix\tSuffixe\tSuffix\t׺\tZ~,
qq~sun\tSun\tdimanche\tSonntag\t\tP~,
qq~thu\tThu\tjeudi\tDonnerstag\t\tP|~,
qq~time\tTime\tHeure\tZeit\tʱ\tɶ~,
qq~timezone\tTime zone\tFuseau horaire\tZeitzone\tʱ\tɰ~,
qq~title\tMessage Title\tTitre\tBetreff\t\tD~,
qq~titlesonly\tTitles only\tTitres seulement\tNur im Betreffe\tֻ\tNdD~,
qq~topic\tTopic\tSujet\tTheme\t\tDD~,
qq~topicindex\tTopic index\tIncr&eacute;ment de sujets\tThemaindex\tĿ¼\tDؿ~,
qq~topics\tTopics\tSujets\tThemen\t\tDD~,
qq~total\tTotal\tTotal\tGesamtmenge\t\t`~,
qq~tue\tTue\tmardi\tDienstag\tڶ\tPG~,
qq~undo\tUndo\tabroger\tnderung zurcknehmen\t\tM~,
qq~unlock\tUnlock\tOuvert\tGe&ouml;ffnet\t\t\\[K~,
qq~unresolvedforum\tunresolved restored forum\tforum restaur&eacute; non d&eacute;fini\tungel&ouml;stes wiederhgeerstelltes Forum\tָ\t`DD~,
qq~unsubscribe\tUnsubscribe\tAnnulez l'abonnement\tBeenden die Subskription\t˶\thq~,
qq~update\tUpdate\tMise &agrave; jour\tAktualisierungsvorgang\t\ts~,
qq~upper\tUpper level\tNiveau sup&eacute;rieur\tHhere Ebene\t\tVW~,
qq~username\tUser name\tNom d'utilisateur\tBenutzername\tû\tΤW~,
qq~users\tUsers management\tGestion d'utilisateurs\tBenutzermanagement\tû\tΤ޲z~,
qq~webmaster\tWebmaster\tle ma&icirc;tre\tVerwalter\t\t~,
qq~wed\tWed\tmercredi\tMittwoch\t\tPT~,
qq~welcome\tWelcome\tBienvenue\tWillkommen\tӭ\tw~,
qq~wholeword\tWhole word only\tMots complets\tvollst&ouml;ndige W&ouml;rter\tƥ\trǰt~,
qq~zip\tZip code\tCode postal\tPostcode\t\tlsX~,
);
#Now make necessary dictionaries.
@langs = ("eng", "fr", "de", "gb", "big5");
@provlangs = split( /\s+/, $fields{'provlangs'} );

for (0..$#langs){
	my $var = "dict" . $langs[$_];
	$langsubs{$langs[$_]} = $_;
	tie( %{$var}, $DB_Type, "dat/$langs[$_]", &GDBM_WRCREAT, 0666 );
}

for (@dictterms){
	my ( $ky, @terms ) = split( /\t/ );
	foreach $lg (@langs){
		my $var = "dict" . $lg;
		${$var}{$ky} = $terms[$langsubs{$lg}];
	}
}

foreach $lg (@langs){
	my $var = "dict" . $lg;
	untie %{$var};
}
# Now set other paramters
tie( %settings, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
$settings{'defaultlang'} = $fields{'langpref'};
$settings{'timezone'} = $fields{'timezone'};
$settings{'hidelangbuttons'} = $fields{'hidelangbuttons'};
$settings{'provlangs'} = join( "\t", @provlangs );
$settings{'timegb'} = "{year}{mon}{day}{wday}{hour}{min}";
$settings{'timeeng'} = "{0hour}:{0min}, {0mon}/{0day}/{yr} [{wday}]";
$settings{'timefr'} = "{hour}h{min}, {mon} {day}, {year}";
$settings{'timede'} = "{wday}, {mon} {day} {year} {hour}:{min}";
$settings{'timebig5'} = "{year}~{mon}{day}{wday}{hour}{min}";
untie %settings;
tie( %users, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
@mydata = split( /\t/, $users{'1'} );
$mydata[16] = $fields{'langpref'};
$mydata[18] = $fields{'mytimezone'};
$users{'1'} = join( "\t", @mydata );
untie %users;
#cut
if( -e "bbs.cfg" ){
	# For upgrading from lower versions only
	$FL_overlookreferer = 1;
	require "bbs.cfg";
	$validrefs = "www$mydomain, " . substr( $mydomain, 1 );
} else {
	# Try to find out the domain.
    $validrefs = join( ", ", $ENV{'HTTP_HOST'}, $ENV{'SERVER_NAME'}, $ENV{'SERVER_ADDR'} );
	$mydomain = "." . $ENV{'SERVER_NAME'};
	$mailprog = "/usr/sbin/sendmail";
}

%msgs = (
'title' => [
	qq{Step 3: Forum settings},
	qq{&Eacute;tape 3: Param&eacute;tres du forum},
	qq{Jobstep 3: Forumeinstellungen},
	qq{̳},
	qq{ĤTBG׾³]m},
	],
'pathinfo' => [
	qq{Path info},
	qq{L'information de voie d'acc&egrave;s},
	qq{Pfadinformationen},
	qq{·Ϣ},
	qq{|H},
	],
'prompt' => [
	qq{If you are upgrading an older version of Forum Engine, some of the following fields are likely have been filled out for you with current settings on your site. Please check and make corrections if necessary.},
	qq{Si vous am&eacute;liorez une version plus ancienne de moteur de forum, certaines des zones suivantes sont probables ont &eacute;t&eacute; compl&eacute;t&eacute;es pour vous de configurations actuelles sur votre site. Contr&ocirc;lez et veuillez faites les corrections au besoin.},
	qq{Wenn Sie eine &auml;ltere Version der Forum Engine ausbauen, sind einige der folgenden Felder sind gef&uuml;llt worden heraus f&uuml;r Sie mit aktuellen Einstellungen auf Ihrer Site wahrscheinlich. Bitte &uuml;berpr&uuml;fen Sie und bilden Sie Korrekturen wenn notwendig.},
	qq{ǴForum EngineĵͰ汾µĲĿѾȥãǷȷ},
	qq{pGzOqForum EngineCiɯšAHUإiwgnFzLh]mAˬdO_̡C},
	],
'baseurl' => [
	qq{Base URL},
	qq{URL de base},
	qq{Unterseite URL},
	qq{URLַ},
	qq~URLa}¦~,
	],
'sitehome' => [
	qq{Site homepage},
	qq{Homepage de site},
	qq{Site homepage},
	qq{վҳ},
	qq{D},
	],
'location' => [
	qq{Location},
	qq{Emplacement},
	qq{Standort},
	qq{λ},
	qq{m},
	],
'mydomain' => [
	qq{Domain name},
	qq{Domain},
	qq{Meines Domain},
	qq{},
	qq{W},
	],
'posting' => [
	qq{Posting options},
	qq{Affichage},
	qq{Optionen},
	qq{ѡ},
	qq~iKﶵ~,
	],
'validrefs' => [
	qq{Valid HTTP-referer domains},
	qq{Domaines valides de HTTP-referer},
	qq{G&uuml;ltige HTTP-referer domains},
	qq{Ч},
	qq~ĪӳXW~,
	],
'explainbase' => [
	qq{This is the URL for accessing standard files such as images.},
	qq{C'est le URL pour acc&eacute;der &agrave; aux fichiers standard tels que des images.},
	qq{Dieses ist das URL f&uuml;r der Standarddateien wie Bilder.},
	qq{ͨһַȡͼļһHTMLĵȷ},
	qq~qLo\@a}Ūn󪺹ϧΤM\@HTMLɡCpGz̩wAпJ~,
	],
'explaindom' => [
	qq{The domain name of your site does not contain the preceding "www", but begins with the first dot. This information will be used for writing HTTP cookies, which are essential for monitoring log-in sessions. Follow this example:},
	qq{Le Domain Name de votre site ne contient pas le "www" pr&eacute;c&eacute;dant, mais commence par le premier point. Cette information sera utilis&eacute;e pour les biscuits de HTTP d'&eacute;criture, qui sont essentiels pour surveiller des sessions de proc&eacute;dure de connexion. Suivez cet exemple:},
	qq{Das Domain Name Ihrer Sites enth&auml;lt nicht das vorangehende "www", aber f&auml;ngt mit dem ersten Punkt an. Diese Informationen werden f&uuml;r Schreiben HTTP "ccokies", die f&uuml;r die &uuml;berwachung von Sitzungen wesentlich sind. Folgen Sie diesem Beispiel:},
	qq{վǰ׺wwwǴӵһ㿪ʼһϢڼ¼Cookie͵¼Ϣ׼ȷ롣δ},
	qq~WaewwwAӬOqĤ\@ӥyI۩lCo\@HNΤ_OsCookieMnHAȽЭ̿JCаѦҡG~,
	],
'explainrefs' => [
	qq{Please enter the valid visiting domain names -- normally the current domain with or without the preceding "www" and its numerical form -- separated by space (a comma or semicolon may be used also). Please omit the "http://" portion. For example:},
	qq{Veuillez &eacute;crire les noms valides de domaine de visiter -- normalement le domaine actuel avec ou sans "www" pr&eacute;c&eacute;dant et sa forme num&eacute;rique -- s&eacute;par&eacute;s par l'espace (une virgule ou un point-virgule peut &ecirc;tre utilis&eacute;e &eacute;galement). Veuillez omettre l' "http://" partie. Par exemple:},
	qq{Tragen Sie bitte die g&uuml;ltigen Domain Namen -- normalerweise das aktuelle Gebiet mit oder ohne das vorangehende "www" und sein numerisches Formular -- getrennt durch Platz ein (ein Komma oder ein Semicolon k&ouml;nnen auch verwendet werden). Lassen Sie bitte das "http://" aus. Zum Beispiel:},
	qq{ָõͨڵ䲻wwwǰ׺ĲԼʽöšֺԼոָЩ},
	qq~Ыw\\ӳXWAq`o]Az{bWΨ䤣awwwe󪺳HμƦrΦCziHγrBHΪŮjoǰWCҦp~,
	],
'errnopath' => [
	qq{The base url and site homepage should not be left blank.},
	qq{Le URL de base et le homepage de site ne devraient pas &ecirc;tre laiss&eacute;s blanc.},
	qq{Das Unterseite URL und das Site-homepage sollten nicht freigelassen werden.},
	qq{URLַվҳַӦΪհס},
	qq~¦URLa}MIDa}ť~,
	],
'nextstep' => [
	qq{Next step},
	qq{Prochaine &eacute;tape},
	qq{Folgender Jobstep},
	qq{һ},
	qq{U\@B},
	],
);
print <<FORM;
<td>
<script language="JavaScript">
function validate( frm ){
	if( !frm.baseurl.value || !frm.siteroot.value ){
		alert( "$msgs{'errnopath'}[$langsub]" );
		return false;
	}
	return true;
}
</script>
<input type="hidden" name="step" value="4">
<input type="hidden" name="lang" value="$lang">
<table border=0 cellspacing=0 cellpadding=0>
<tr>
	<td width=8><img src="$pssurl/img/tagleft.gif" width=8 height=16 border=0></td>
	<td background="$pssurl/img/tagbg.gif"><b>$msgs{'title'}[$langsub]</b></td>
	<td width=8><img src="$pssurl/img/tagright.gif" width=8 height=16 border=0></td>
</tr>
</table>
<table border=0 cellspacing=0 cellpadding=0 width="100%">
<tr>
	<td background="$pssurl/img/barbg.gif"><img src="$pssurl/img/clear.gif" border=0 height=8 width=12></td>
</tr>
</table>
</td>
</tr>
<tr>
<td bgcolor="#3232D8">
<table border=0 cellspacing=1 cellpadding=2 width="100%">
<tr>
	<td bgcolor="white" align=right>$msgs{'pathinfo'}[$langsub]</td>
	<td bgcolor="white">
	$msgs{'prompt'}[$langsub]<br><hr size=1 color="\#2020D8" noshade>
	<table width=100% cellspacing=0 cellpadding=0 border=0>
	<tr><td valign="top">$msgs{'baseurl'}[$langsub]<td><input type="Text" size="30" maxlenth="80" name="baseurl" value="$baseurl"> <img src="$pssurl/img/marknote.gif" width=10 height=10><br>
	* $msgs{'explainbase'}[$langsub] <code>$pssroot/forum</code><br><br>
	</td></tr>
	<tr><td valign="top">$msgs{'sitehome'}[$langsub]<td><input type="Text" size="30" maxlenth="80" name="siteroot" value="$siteroot"> <img src="$pssurl/img/marknote.gif" width=10 height=10><br><br></td></tr>
	<tr><td valign="top">$msgs{'mydomain'}[$langsub]<td><input type="Text" size="30" maxlenth="80" name="mydomain" value="$mydomain"> <img src="$pssurl/img/marknote.gif" width=10 height=10><br>
	* $msgs{'explaindom'}[$langsub]<code>.perlstudio.de</code><br><br></td></tr>
	<tr><td valign="top">$msgs{'validrefs'}[$langsub]<td><input type="Text" size="30" maxlenth="200" name="validrefs" value="$validrefs"> <img src="$pssurl/img/marknote.gif" width=10 height=10><br>
	* $msgs{'explainrefs'}[$langsub] <code>www.perlstudio.de, perlstudio.de, 212.227.82.238</code><br><br></td></tr>
	</table>
	</td>
</tr>
<tr>
	<td bgcolor="white" align=right>$msgs{'sendmail'}[$langsub]</td>
	<td bgcolor="white">
	Please chose the method to send out emails. <img src="$pssurl/img/marknote.gif" width=10 height=10><br>
	<input type="radio" name="emailmethod" value="sendmail" Checked> Use Sendmail (Unix)<br>
	&nbsp;&nbsp;&nbsp;&nbsp;$msgs{'location'}[$langsub] <input type="Text" size="30" maxlenth="80" name="mailprog" value="$mailprog"><br>
	<input type="radio" name="emailmethod" value="blat"> Use blat.exe (Window NT)<br>
	&nbsp;&nbsp;&nbsp;&nbsp;$msgs{'location'}[$langsub] <input type="Text" size="30" maxlenth="80" name="blatprog" value="c:\\blat\\blat.exe"><br>
	<input type="radio" name="emailmethod" value="smtp"> Use socket-level programming<br>
	&nbsp;&nbsp;&nbsp;&nbsp;$msgs{'location'}[$langsub] <input type="Text" size="30" maxlenth="80" name="smtpserver" value="$ENV{'SERVER_NAME'}">
	</td>
</tr>
<tr>
	<td bgcolor="white" align=right colspan=2>
	<input type="submit" value="&gt;&gt; $msgs{'nextstep'}[$langsub]">
	</td>
</tr>
</table>
</td>
FORM
}

sub step4 {
#debug
tie( %settings, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
map { $settings{$_} = $fields{$_} } qw(baseurl siteroot sendmail mydomain validrefs mailprog blatprog smtpserver emailmethod);
map { $settings{$_} = 1 } qw(guestpost appendlast hideip autoinform expandall markwebmaster hidepoptopics findemoticons findhyperlinks showfollowups jumpform disabledeltree intellirestore intellidestroy skipcountsubs);
map { $settings{$_} = 0 } qw(allowhtml sendmeall wordfilter exptbtext markusergroups hideonline insertimage countsubhits);
$settings{'maxlistentry'} = 20;
$settings{'newmsgtime'} = 48;
$settings{'expiretime'} = 30;
$settings{'checkupsess'} = 24;
$settings{'defaultline'} = 1;
$settings{'maxreplydepth'} = 8;
$settings{'theader'} = "DarkBlue";
$settings{'theaderfg'} = "White";
$settings{'tr0'} = "White";
$settings{'tr0fg'} = "Black";
$settings{'tr0sub'} = "White";
$settings{'tr0subfg'} = "Black";
$settings{'tr1'} = "White";
$settings{'tr1fg'} = "Black";
$settings{'tr1sub'} = "White";
$settings{'tr1subfg'} = "Black";
$settings{'col0'} = "";
$settings{'col1'} = "#EEEEEE";
$settings{'col2'} = "";
$settings{'col3'} = "";
$settings{'col0fg'} = "";
$settings{'col1fg'} = "";
$settings{'col2fg'} = "";
$settings{'col3fg'} = "";
$settings{'othbg'} = "White";
$settings{'othfg'} = "Black";
$settings{'tblbg'} = "Black";
untie %settings;
# For upgrading from lower versions only
if( -e "bbs.cfg" ){
	$FL_overlookreferer = 1;
	require "bbs.cfg";
} else {
	$mayimport = "disabled";
}
#cut
%msgs = (
'title' => [
	qq{Step 4: Initiatiate and import},
	qq{&Eacute;tape 4: Initiatiate et importation},
	qq{Jopstep 4: Initiatiate und Import},
	qq{Ĳʼ鼰},
	qq{ĤBGlQײդΤޤJ¶K},
	],
'forumtitle' => [
	qq{Forum title},
	qq{Titre de forum},
	qq{Forumname},
	qq{̳},
	qq{׾¼D},
	],
'prompttitle' => [
	qq{Chose your forum a nice title!},
	qq{A choisi un titre gentil pour votre forum!},
	qq{W&auml;hlte einen netten Namen f&uuml;r Ihr Forum!},
	qq{Ϊ̳ѡһƯ֣},
	qq{z׾¬D@谦WrI},
	],
'topics' => [
	qq{Initial topics},
	qq{Sujets initiaux},
	qq{Ausgangsthemen},
	qq{ʼ},
	qq{lQײ},
	],
'prompttopics' => [
	qq{For your convenience, you can choose up to three forum topics now. You can always create or remove any forums anytime later. Just find the buttons in the tool bar.},
	qq{Pour votre convenance, vous pouvez choisir jusqu'&agrave; trois sujets de forum maintenant. Vous pouvez toujours cr&eacute;er ou enlever tous les forum n'importe quand plus tard. Trouvaille juste que les boutons dans l'outil barrent.},
	qq{F&uuml;r Ihre Bequemlichkeit k&ouml;nnen Sie bis drei Forumthemen jetzt w&auml;hlen. Sie k&ouml;nnen alle m&ouml;gliche Foren immer herstellen oder zu jeder Zeit sp&auml;ter l&ouml;schen. Gerade Entdeckung, welche die Tasten im Hilfsmittel abhalten.},
	qq{һνͬ顣̳кʱɾ⽨༶顣},
	qq{K_AziH\@إߦhܤTӤPQײաC׾¹BZziHɼWRANإߦhŤաC},
	],
'desc' => [
	qq{Brief description},
	qq{Courte description},
	qq{Kurze Beschreibung},
	qq{̽},
	qq{²u},
	],
'import' => [
	qq{Import},
	qq{Importation},
	qq{Import},
	qq{},
	qq{ޤJ¶K},
	],
'promptimport' => [
	qq{Check to import the messages in the existing version and specify a name for the forum that will host these imported messages:},
	qq{Contr&ocirc;lez pour importer les messages dans la version existante et pour indiquer un nom pour le forum qui accueillera ces messages import&eacute;s.},
	qq{&Uuml;berpr&uuml;fen Sie, um die Meldungen in der vorhandenen Version zu importieren und einen Namen f&uuml;r das Forum zu spezifizieren, das diese importierten Meldungen bewirtet.},
	qq{Ѿɰ汾תָ⣺},
	qq~ªlഫiӡA}ЫwռDG~,
	],
'importtitle' => [
	qq{Messages imported from previous version},
	qq{Messages import&eacute;s de la version pr&eacute;c&eacute;dente.},
	qq{Meldungen importiert aus vorhergehender Version},
	qq{תľ},
	qq~ഫ¶K~,
	],
'errnoforum' => [
	qq{You have to make at least one forum.},
	qq{Vous devez faire au moins un forum.},
	qq{Sie m&uuml;ssen mindestens ein Forum bilden.},
	qq{Ӧöһɡ},
	qq{zܤөwq\@ӰQײէaC},
	],
'nextstep' => [
	qq{Next step},
	qq{Prochaine &eacute;tape},
	qq{Folgender Jobstep},
	qq{һ},
	qq{U\@B},
	],
);
print <<FORM;
<td>
<script language="JavaScript">
function validate( frm ){
	if( !frm.topic1.value && !frm.topic2.value && !frm.topic3.value ){
		alert( "$msgs{'errnoforum'}[$langsub]" );
		return false;
	}
	return true;
}
</script>
<input type="hidden" name="step" value="5">
<input type="hidden" name="lang" value="$lang">
<table border=0 cellspacing=0 cellpadding=0>
<tr>
	<td width=8><img src="$pssurl/img/tagleft.gif" width=8 height=16 border=0></td>
	<td background="$pssurl/img/tagbg.gif"><b>$msgs{'title'}[$langsub]</b></td>
	<td width=8><img src="$pssurl/img/tagright.gif" width=8 height=16 border=0></td>
</tr>
</table>
<table border=0 cellspacing=0 cellpadding=0 width="100%">
<tr>
	<td background="$pssurl/img/barbg.gif"><img src="$pssurl/img/clear.gif" border=0 height=8 width=12></td>
</tr>
</table>
</td>
</tr>
<tr>
<td bgcolor="#3232D8">
<table border=0 cellspacing=1 cellpadding=2 width="100%">
<tr>
	<td bgcolor="white" align=right>$msgs{'forumtitle'}[$langsub]</td>
	<td bgcolor="white">$msgs{'prompttitle'}[$langsub]<br>
	<input type="text" name="bbstitle" size=40 maxlength=80 value="$bbstitle">
</tr>
<tr>
	<td bgcolor="white" align=right>$msgs{'topics'}[$langsub]</td>
	<td bgcolor="white">$msgs{'prompttopics'}[$langsub]<br>
	<ol type="1">
	<li><input type="text" name="topic1" size=40 maxlength=80><br>
	<textarea name="desc1" cols=30 rows=3>($msgs{'desc'}[$langsub])</textarea>
	<li><input type="text" name="topic2" size=40 maxlength=80><br>
	<textarea name="desc2" cols=30 rows=3>($msgs{'desc'}[$langsub])</textarea>
	<li><input type="text" name="topic3" size=40 maxlength=80><br>
	<textarea name="desc3" cols=30 rows=3>($msgs{'desc'}[$langsub])</textarea>
	</ol>
</tr>
<tr>
	<td bgcolor="white" align=right>$msgs{'import'}[$langsub]</td>
	<td bgcolor="white">
	<input type="checkbox" name="importnow" value="1" $mayimport> $msgs{'promptimport'}[$langsub]<br>
	<input type="text" name="importforumtitle" size=40 maxlength=80 value="$msgs{'importtitle'}[$langsub]">
	</td>
	</td>
</tr>
<tr>
	<td bgcolor="white" align=right colspan=2>
	<input type="submit" value="&gt;&gt; $msgs{'nextstep'}[$langsub]">
	</td>
</tr>
</table>
</td>
FORM
}

sub step5 {
#debug
# Now create the topics.dat data file
tie( %settings, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
$topics = 0;
open( TP, ">dat/topics.dat" );
flock( TP, LOCK_EX );
# This is the must-have first line
print TP join( "\t", "\t0", $fields{'bbstitle'}, 1, time, 0, 1 );
for( 1..3 ){
	my $tpname = "topic" . $_;
	my %frdb = ( );
	if( $fields{$tpname} !~ /^\s*$/ ){
		$topics++;
		print TP join( "\t", "\n", "\t", $topics, $fields{$tpname}, 1, time, 0, 1 );
		open( FR, ">dat/fr$topics.dat" );
		flock( FR, LOCK_EX );
		print FR join( "\t", "", 0, $fields{$tpname}, 1, time, 0, 1 );
		flock( FR, LOCK_UN );
		close( FR );
		$settings{'fr'.$topics} = $fields{'desc'.$topics};
		tie( %frdb, $DB_Type, "dat/fr$topics", &GDBM_WRCREAT, 0666 );
		$frdb{'nummsgs'} = 0;
		untie( %frdb );
	}
}
flock( TP, LOCK_UN );
close( TP );

# Now update the "forum" database
$settings{'bbstitle'} = $fields{'bbstitle'};
$settings{'numtopics'} = $topics;
$settings{'nexttopicid'} = $topics + 1;
$settings{'nextmsgid'} = 1;
$settings{'nummsgs'} = 0;
untie %settings;

# Now import old messages. Some versions may store the "index.htt" in the same folder with the scripts,
# while some others (since version 1.7) store it under "template"
if( $fields{'importnow'} ){
	# In case "bbs.cfg" not found, try default settings that suits most cases
	$tpldir = "template";
	$datadir = "data";
	$msgdir = "message";
	if( -e "bbs.cfg" ){
		$FL_overlookreferer = 1;
		require "bbs.cfg";
	}
	if( !defined $basedir ){
		$basedir = ".";
		$tpldir = ".";
	}
	my %users = ( );	# Will store user information into the database "users"
	my %userids = ( );	# Store user ids temporarily
	my $userid = 2;		# The first userid is 2 in database "users" at this stage
	my %reads = ( );	# Store hits for messages
	if( open( USERS, "<$datadir/userlist.cgi" ) ){
		tie( %users, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
		while( <USERS> ){
			next if( /^\s*$/ );
			my @udata = split( /\t/ );
			# Username, password, email, homepage, image
			next unless( $udata[2] && ( $udata[0] ne "webmaster" ) && $udata[0] !~ /\W/ );
			# Skip those users without an email address, the webmaster, and the username with invalid characters
			$users{$userid} = join( "\t", $udata[0], $udata[1], 3, $udata[0], "", "", "", "", "U", $udata[2], "\t" x 8 );
			$userids{ lc( $udata[0] ) } = $userid++;	# Store in lower-case
		}
		close( USERS );
		$users{'nextuserid'} = $userid;
		$users{'numusers'} = $userid - 1;
		untie %users;
	}
	if( open( RC, "<$datadir/rcdat.cgi" ) ){
		while( <RC> ){
			next if( /^\s*$/ );
			chomp;
			my @rdata = split( /:/ );
			$reads{$rdata[0]} = $rdata[1];
		}
		close( RC );
	}
	my ( %titles, %authors, %ips );
	if( open( INFO, "<$datadir/bbslist.cgi" ) ){
		while( <INFO> ){
			next if( /^\s*$/ );
			chomp;
			my @fdata = split( /\t/ );
			my $msgid = $fdata[0];
			# message id, author name, title, time, remote address
			( $authors{$msgid}, $titles{$msgid}, $dummyvar, $ips{$msgid} ) = @fdata[1..4];
		}
		close( INFO );
	}
	unless( open( IDX, "<$basedir/$tpldir/$indexfile" ) ){
		return;
	}
	my ( $dep, $lastdep ) = ( 1, 0 );
	my ( $title, $author, $lastmod, $msgid, $authorid, $currmsg );
	# $msgid will store original message id for accessing message files, while $currmsg contain id in the new database
	$topics++;
	open( FR, ">dat/fr$topics.dat" );
	$lastmsg = join( "\t", "", 0, $fields{'importforumtitle'}, 1, time, 0, 0 );
	# The imported forum is set to be closed. No new messages allowed to post here.
	tie( %frdb, $DB_Type, "dat/fr$topics", &GDBM_WRCREAT, 0666 );
	while( <IDX> ){
		chomp;
		if( m{^<!-- Xref\d+ (\d+) Msg(\d+) -->} ){
			print FR "\t" x $lastdep, $lastmsg, "\n";
			$dep++;
			$lastdep = $dep;
			( $lastmod, $msgid ) = ( $1, $2 );
			$currmsg++;
			$authorid = 0;
			if( defined $userids{ lc($authors{$msgid}) } ){
				$authorid = $userids{ lc($authors{$msgid}) };
			} # Only record those retained users
			$lastmsg = join( "\t", $currmsg, $titles{$msgid}, $authorid, $lastmod, ($reads{$msgid} || 0), 1 );
			$msgcontent = "";
			if( open( TMP, "$basedir/$msgdir/msg$msgid.html" ) ){
				while( <TMP> ){
					last if( /<!-- Edit begin -->/ );
				}
				while( <TMP> ){
					last if( /<!-- Edit end -->/ );
					$msgcontent .= $_;
				}
				close( TMP );
				$msgcontent =~ s/\t/ /g;
			}
			$frdb{$currmsg} = join( "\t", $authorid, $ips{$msgid}, $lastmod, $titles{$msgid}, $msgcontent );
		} elsif( m{^<!-- Msg\d+ end -->} ){
			$dep--;
		}
	}
	print FR "\t" x $lastdep, $lastmsg;
	close( IDX );
	close( FR );
	$frdb{'nummsgs'} = $currmsg;
	untie %frdb;
	tie( %settings, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
	$settings{'numtopics'}++;
	$settings{'nexttopicid'}++;
	$settings{'nummsgs'} = $currmsg;
	$settings{'nextmsgid'} = $currmsg + 1;
	untie %settings;
	open( TPC, ">>dat/topics.dat" );
	print TPC "\n", join( "\t", "\t", $topics, "$fields{'importforumtitle'}", 1, time, $currmsg, 1 );
	close( TPC );
}
#cut
# Now make a dictionary to display the form text
require "inc/localize.pl";
&makedict;

%msgs = (
'title' => [
	qq{Step 5: Personal information},
	qq{&Eacute;tape 5: L'information personnelle},
	qq{Jopstep 5: Pers&ouml;nliche Informationen},
	qq{岽Ϣ},
	qq{ĤBGӤHH},
	],
'promptsign' => [
	qq{This information can be appended to any messages and emails you write.},
	qq{Cette information peut &ecirc;tre ajout&eacute;e &agrave; tous les messages et email que vous &eacute;crivez},
	qq{Diese Informationen k&ouml;nnen zu allen m&ouml;glichen Meldungen und zu email angef&uuml;gt werden, die Sie schreiben.},
	qq{ЩϢӵӺ͵ʼС},
	qq{oǫHN[zlMqll󤤡C},
	],
'preformatted' => [
	qq{Check if it is preformatted (fixed-width characters).},
	qq{Contr&ocirc;lez si elle est pr&eacute;format&eacute;e (des caract&egrave;res de fixe-largeur).},
	qq{&Uuml;berpr&uuml;fen Sie, ob es preformatted (&ouml;rtlich festgelegt-Breite Zeichen).},
	qq{̶ַȵԤʽϢ},
	qq{Twrżeתw榡ƫHC},
	],
'errnoname' => [
	qq{Please fill in both your first and last name.},
	qq{Veuillez compl&eacute;ter votre deux premier et dernier nom.},
	qq{F&uuml;lle Sie bitte beides Ihren Vornamen und Familiennameen aus.},
	qq{дմ},
	qq{жgzLmjWC},
	],
'nextstep' => [
	qq{Done! Lauch the forum!},
	qq{Fait! Lauch le forum!},
	qq{Getan! Lauch das Forum!},
	qq{󹦸ɣ˼̳},
	qq{j\\iIiJ׾},
	],
);
print <<FORM;
<td>
<script language="JavaScript">
function validate( frm ){
	if( !frm.firstname.value || !frm.lastname.value ){
		alert( "$msgs{'errnoname'}[$langsub]" );
		return false;
	}
	return true;
}
</script>
<input type="hidden" name="step" value="6">
<input type="hidden" name="lang" value="$lang">
<table border=0 cellspacing=0 cellpadding=0>
<tr>
	<td width=8><img src="$pssurl/img/tagleft.gif" width=8 height=16 border=0></td>
	<td background="$pssurl/img/tagbg.gif"><b>$msgs{'title'}[$langsub]</b></td>
	<td width=8><img src="$pssurl/img/tagright.gif" width=8 height=16 border=0></td>
</tr>
</table>
<table border=0 cellspacing=0 cellpadding=0 width="100%">
<tr>
	<td background="$pssurl/img/barbg.gif"><img src="$pssurl/img/clear.gif" border=0 height=8 width=12></td>
</tr>
</table>
</td>
</tr>
<tr>
<td bgcolor="#3232D8">
<table border=0 cellspacing=1 cellpadding=2 width="100%">
<tr>
	<td bgcolor="white" align=right>$dict{'firstname'}(<u>F</u>)</td>
	<td bgcolor="white"><input type="Text" accesskey="f" name="firstname" size="12" maxlength="60" vcard_name="vCard.FirstName"> <img src="$pssurl/img/marknote.gif" width=10 height=10>
	</td>
</tr>
<tr>
	<td bgcolor="white" align=right>$dict{'lastname'} (<u>L</u>)</td>
	<td bgcolor="white"><input type="Text" accesskey="l" name="lastname" size="12" maxlength="60" vcard_name="vCard.LastName"> <img src="$pssurl/img/marknote.gif" width=10 height=10><br>
	$dict{'suffix'} (<u>X</u>) <input type="Text" accesskey="x" name="suffix" size="4" maxlength="8" vcard_name="vCard.Suffix">
	$dict{'midinit'} (<u>T</u>) <input type="Text" accesskey="t" name="midinit" size="2" maxlength="2" vcard_name="vCard.MiddleName"></td>
</tr>
<tr>
	<td bgcolor="white" align=right>$dict{'sex'}</td>
	<td bgcolor="white"><input type="Radio" name="gender" value="F"> $dict{'female'}
	<input type="Radio" name="gender" value="M"> $dict{'male'}
	<input type="Radio" name="gender" value="U" checked> $dict{'keepsecret'}</td>
</tr>
<tr>
	<td bgcolor="white" align=right>$dict{'streetln1'} (<u>R</u>)</td>
	<td bgcolor="white"><input type="Text" name="streetln1" accesskey="r" size="30" maxlength="300" vcard_name="vCard.Home.StreetAddress"><br>
	<input type="Text" name="streetln2" size="30" maxlength="300"></td>
</tr>
<tr>
	<td bgcolor="white" align=right>$dict{'city'} (<u>Y</u>)</td>
	<td bgcolor="white"><input type="Text" name="city" accesskey="y" size="10" maxlength="50" vcard_name="vCard.Home.City">&nbsp;&nbsp;$dict{'state'} (<u>S</u>) <input type="Text" name="state" accesskey="s" size="10" maxlength="50" vcard_name="vCard.Home.State"></td>
</tr>
<tr>
	<td bgcolor="white" align=right>$dict{'zip'} (<u>Z</u>)</td>
	<td bgcolor="white"><input type="Text" name="zip" accesskey="z" size="10" maxlength="20" vcard_name="vCard.Home.Zipcode">&nbsp;&nbsp;$dict{'country'} (<u>U</u>) <input type="Text" name="country" accesskey="u" size="30" maxlength="50" value="USA" vcard_name="vCard.Home.Country"></td>
</tr>
<tr>
	<td bgcolor="white" align=right valign=top>$dict{'emailsign'}</td>
	<td bgcolor="white">
	$msgs{'promptsign'}[$langsub]<br>
	<textarea name="emailsign" accesskey="g" cols="40" rows="5" wrap="VIRTUAL"></textarea>
	<br>
	<input type="checkbox" name="preformatted"> $msgs{'preformatted'}[$langsub]
	</td>
</tr>
<tr>
	<td bgcolor="white" align=right colspan=2>
	<input type="submit" value="&gt;&gt; $msgs{'nextstep'}[$langsub]">
	</td>
</tr>
</table>
</td>
FORM
}
